package org.kathra.resourcemanager;

import org.kathra.utils.security.KeycloakUtils;
import org.kathra.core.model.ApiVersion;
import org.apache.camel.model.dataformat.JsonLibrary;
import org.kathra.core.model.Assignation;
import org.kathra.core.model.BinaryRepository;
import org.kathra.core.model.CatalogEntry;
import org.kathra.core.model.CatalogEntryPackage;
import org.kathra.core.model.Component;
import org.kathra.core.model.Implementation;
import org.kathra.core.model.Group;
import org.kathra.core.model.ImplementationVersion;
import org.kathra.core.model.KeyPair;
import org.kathra.core.model.Library;
import org.kathra.core.model.LibraryApiVersion;
import org.kathra.core.model.Pipeline;
import org.kathra.core.model.SourceRepository;
import org.kathra.core.model.User;
import org.kathra.KathraAuthRequestHandlerImpl;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.cdi.ContextName;
import org.apache.camel.model.rest.RestBindingMode;
import static org.apache.camel.model.rest.RestParamType.*;

@ContextName("ResourceManager")
public class ResourceManagerApi extends RouteBuilder {

    @Override
    public void configure() throws Exception {
        KeycloakUtils.init();
        // configure we want to use servlet as the component for the rest DSL
        // and we enable json binding mode
        restConfiguration().component(org.kathra.iface.KathraAuthRequestHandler.HTTP_SERVER)
        // use json binding mode so Camel automatic binds json <--> pojo
        .bindingMode(RestBindingMode.off)
        // and output using pretty print
        .dataFormatProperty("prettyPrint", "true")
        .dataFormatProperty("json.in.disableFeatures", "FAIL_ON_UNKNOWN_PROPERTIES")
        // setup context path on localhost and port number that netty will use
        .contextPath("/api/v1")
        .port("{{env:HTTP_PORT:8080}}")
        .componentProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))
        .endpointProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))
        .consumerProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))

        // add swagger api-doc out of the box
        .apiContextPath("/swagger.json")
        .apiProperty("api.title", "Kathra Resource Manager")
        .apiProperty("api.version", "1.0.0-RC-SNAPSHOT")
        .apiProperty("api.description", "ResourceManager")
        // and enable CORS
        .apiProperty("cors", "true")
        .enableCORS(true).corsAllowCredentials(true)
        .corsHeaderProperty("Access-Control-Allow-Headers", "Origin, Accept, X-Requested-With, Content-Type," +
                "Access-Control-Request-Method, Access-Control-Request-Headers, Authorization");

        rest()

        .post("/apiversions").type(ApiVersion.class).outType(ApiVersion.class)
            .description("Add a new apiversion")
                .param()
                    .required(true)
                    .name("apiversion")
                    .type(body)
                    .description("ApiVersion object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,ApiVersion.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=addApiVersion(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/apiversions/{resourceId}").outType(String.class)
            .description("Delete a registered apiversion")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=deleteApiVersion(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/apiversions/{resourceId}").outType(ApiVersion.class)
            .description("Retrieve a specific apiversion object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=getApiVersion(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/apiversions").outType(ApiVersion[].class)
            .description("Retrieve a list of accessible apiversions for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=getApiVersions")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/apiversions/{resourceId}").type(ApiVersion.class).outType(ApiVersion.class)
            .description("Fully update a registered apiversion")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("apiversion")
                    .type(body)
                    .description("ApiVersion object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,ApiVersion.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=updateApiVersion(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/apiversions/{resourceId}").type(ApiVersion.class).outType(ApiVersion.class)
            .description("Partially update a registered apiversion")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("apiversion")
                    .type(body)
                    .description("ApiVersion object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,ApiVersion.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=updateApiVersionAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/assignations").type(Assignation.class).outType(Assignation.class)
            .description("Add a new assignation")
                .param()
                    .required(true)
                    .name("assignation")
                    .type(body)
                    .description("Assignation object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Assignation.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:AssignationsController?method=addAssignation(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/assignations/{resourceId}").outType(String.class)
            .description("Delete a registered assignation")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:AssignationsController?method=deleteAssignation(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/assignations/{resourceId}").outType(Assignation.class)
            .description("Retrieve a specific assignation object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:AssignationsController?method=getAssignation(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/assignations").outType(Assignation[].class)
            .description("Retrieve a list of accessible assignations for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:AssignationsController?method=getAssignations")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/assignations/{resourceId}").type(Assignation.class).outType(Assignation.class)
            .description("Fully update a registered assignation")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("assignation")
                    .type(body)
                    .description("Assignation object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Assignation.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:AssignationsController?method=updateAssignation(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/assignations/{resourceId}").type(Assignation.class).outType(Assignation.class)
            .description("Partially update a registered assignation")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("assignation")
                    .type(body)
                    .description("Assignation object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Assignation.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:AssignationsController?method=updateAssignationAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/binaryrepositories").type(BinaryRepository.class).outType(BinaryRepository.class)
            .description("Add a new binaryrepository")
                .param()
                    .required(true)
                    .name("binaryrepository")
                    .type(body)
                    .description("BinaryRepository object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,BinaryRepository.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:BinaryRepositoriesController?method=addBinaryRepository(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/binaryrepositories/{resourceId}").outType(String.class)
            .description("Delete a registered binaryrepository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:BinaryRepositoriesController?method=deleteBinaryRepository(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/binaryrepositories").outType(BinaryRepository[].class)
            .description("Retrieve a list of accessible binaryrepositories for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:BinaryRepositoriesController?method=getBinaryRepositories")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/binaryrepositories/{resourceId}").outType(BinaryRepository.class)
            .description("Retrieve a specific binaryrepository object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:BinaryRepositoriesController?method=getBinaryRepository(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/binaryrepositories/{resourceId}").type(BinaryRepository.class).outType(BinaryRepository.class)
            .description("Fully update a registered binaryrepository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("binaryrepository")
                    .type(body)
                    .description("BinaryRepository object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,BinaryRepository.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:BinaryRepositoriesController?method=updateBinaryRepository(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/binaryrepositories/{resourceId}").type(BinaryRepository.class).outType(BinaryRepository.class)
            .description("Partially update a registered binaryrepository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("binaryrepository")
                    .type(body)
                    .description("BinaryRepository object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,BinaryRepository.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:BinaryRepositoriesController?method=updateBinaryRepositoryAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/catalogentries").type(CatalogEntry.class).outType(CatalogEntry.class)
            .description("Add a new catalogentry")
                .param()
                    .required(true)
                    .name("catalogentry")
                    .type(body)
                    .description("CatalogEntry object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,CatalogEntry.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=addCatalogEntry(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/catalogentries/{resourceId}").outType(String.class)
            .description("Delete a registered catalogentry")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=deleteCatalogEntry(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalogentries").outType(CatalogEntry[].class)
            .description("Retrieve a list of accessible catalogentries for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=getCatalogEntries")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalogentries/{resourceId}").outType(CatalogEntry.class)
            .description("Retrieve a specific catalogentry object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=getCatalogEntry(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/catalogentries/{resourceId}").type(CatalogEntry.class).outType(CatalogEntry.class)
            .description("Fully update a registered catalogentry")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("catalogentry")
                    .type(body)
                    .description("CatalogEntry object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,CatalogEntry.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=updateCatalogEntry(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/catalogentries/{resourceId}").type(CatalogEntry.class).outType(CatalogEntry.class)
            .description("Partially update a registered catalogentry")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("catalogentry")
                    .type(body)
                    .description("CatalogEntry object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,CatalogEntry.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=updateCatalogEntryAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/catalogentrypackages").type(CatalogEntryPackage.class).outType(CatalogEntryPackage.class)
            .description("Add a new catalogentrypackage")
                .param()
                    .required(true)
                    .name("catalogentrypackage")
                    .type(body)
                    .description("CatalogEntryPackage object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,CatalogEntryPackage.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntryPackagesController?method=addCatalogEntryPackage(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/catalogentrypackages/{resourceId}").outType(String.class)
            .description("Delete a registered catalogentrypackage")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntryPackagesController?method=deleteCatalogEntryPackage(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalogentrypackages/{resourceId}").outType(CatalogEntryPackage.class)
            .description("Retrieve a specific catalogentrypackage object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntryPackagesController?method=getCatalogEntryPackage(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalogentrypackages").outType(CatalogEntryPackage[].class)
            .description("Retrieve a list of accessible catalogentrypackages for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntryPackagesController?method=getCatalogEntryPackages")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/catalogentrypackages/{resourceId}").type(CatalogEntryPackage.class).outType(CatalogEntryPackage.class)
            .description("Fully update a registered catalogentrypackage")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("catalogentrypackage")
                    .type(body)
                    .description("CatalogEntryPackage object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,CatalogEntryPackage.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntryPackagesController?method=updateCatalogEntryPackage(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/catalogentrypackages/{resourceId}").type(CatalogEntryPackage.class).outType(CatalogEntryPackage.class)
            .description("Partially update a registered catalogentrypackage")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("catalogentrypackage")
                    .type(body)
                    .description("CatalogEntryPackage object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,CatalogEntryPackage.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntryPackagesController?method=updateCatalogEntryPackageAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/components").type(Component.class).outType(Component.class)
            .description("Add a new component")
                .param()
                    .required(true)
                    .name("component")
                    .type(body)
                    .description("Component object to be created")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("groupPath")
                    .type(query)
                    .description("group's path")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Component.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=addComponent(${body},${header.groupPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/components/{resourceId}").outType(String.class)
            .description("Delete a registered component")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=deleteComponent(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/components/{resourceId}").outType(Component.class)
            .description("Retrieve a specific component object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=getComponent(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/components").outType(Component[].class)
            .description("Retrieve a list of accessible components for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=getComponents")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/components/{resourceId}/implementations").outType(Implementation[].class)
            .description("Retrieve a list of accessible implementations for specific component and authenticated user")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=getImplementationsComponent(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/components/{resourceId}").type(Component.class).outType(Component.class)
            .description("Fully update a registered component")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("component")
                    .type(body)
                    .description("Component object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Component.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=updateComponent(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/components/{resourceId}").type(Component.class).outType(Component.class)
            .description("Partially update a registered component")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("component")
                    .type(body)
                    .description("Component object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Component.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=updateComponentAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/groups").type(Group.class).outType(Group.class)
            .description("Add a new group")
                .param()
                    .required(true)
                    .name("group")
                    .type(body)
                    .description("Group object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Group.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:GroupsController?method=addGroup(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/groups/{resourceId}").outType(String.class)
            .description("Delete a registered group")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:GroupsController?method=deleteGroup(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/groups/{resourceId}").outType(Group.class)
            .description("Retrieve a specific group object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:GroupsController?method=getGroup(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/groups").outType(Group[].class)
            .description("Retrieve a list of accessible groups for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:GroupsController?method=getGroups")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/groups/{resourceId}").type(Group.class).outType(Group.class)
            .description("Fully update a registered group")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("group")
                    .type(body)
                    .description("Group object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Group.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:GroupsController?method=updateGroup(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/groups/{resourceId}").type(Group.class).outType(Group.class)
            .description("Partially update a registered group")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("group")
                    .type(body)
                    .description("Group object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Group.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:GroupsController?method=updateGroupAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/implementationversions").type(ImplementationVersion.class).outType(ImplementationVersion.class)
            .description("Add a new implementationversion")
                .param()
                    .required(true)
                    .name("implementationversion")
                    .type(body)
                    .description("ImplementationVersion object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,ImplementationVersion.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationVersionsController?method=addImplementationVersion(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/implementationversions/{resourceId}").outType(String.class)
            .description("Delete a registered implementationversion")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationVersionsController?method=deleteImplementationVersion(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/implementationversions/{resourceId}").outType(ImplementationVersion.class)
            .description("Retrieve a specific implementationversion object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationVersionsController?method=getImplementationVersion(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/implementationversions").outType(ImplementationVersion[].class)
            .description("Retrieve a list of accessible implementationversions for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationVersionsController?method=getImplementationVersions")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/implementationversions/{resourceId}").type(ImplementationVersion.class).outType(ImplementationVersion.class)
            .description("Fully update a registered implementationversion")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("implementationversion")
                    .type(body)
                    .description("ImplementationVersion object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,ImplementationVersion.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationVersionsController?method=updateImplementationVersion(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/implementationversions/{resourceId}").type(ImplementationVersion.class).outType(ImplementationVersion.class)
            .description("Partially update a registered implementationversion")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("implementationversion")
                    .type(body)
                    .description("ImplementationVersion object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,ImplementationVersion.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationVersionsController?method=updateImplementationVersionAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/implementations").type(Implementation.class).outType(Implementation.class)
            .description("Add a new implementation")
                .param()
                    .required(true)
                    .name("implementation")
                    .type(body)
                    .description("Implementation object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Implementation.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=addImplementation(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/implementations/{resourceId}").outType(String.class)
            .description("Delete a registered implementation")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=deleteImplementation(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/implementations/{resourceId}").outType(Implementation.class)
            .description("Retrieve a specific implementation object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=getImplementation(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/implementations").outType(Implementation[].class)
            .description("Retrieve a list of accessible implementations for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=getImplementations")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/implementations/{resourceId}").type(Implementation.class).outType(Implementation.class)
            .description("Fully update a registered implementation")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("implementation")
                    .type(body)
                    .description("Implementation object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Implementation.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=updateImplementation(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/implementations/{resourceId}").type(Implementation.class).outType(Implementation.class)
            .description("Partially update a registered implementation")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("implementation")
                    .type(body)
                    .description("Implementation object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Implementation.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=updateImplementationAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/keypairs").type(KeyPair.class).outType(KeyPair.class)
            .description("Add a new keypair")
                .param()
                    .required(true)
                    .name("keypair")
                    .type(body)
                    .description("KeyPair object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,KeyPair.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:KeyPairsController?method=addKeyPair(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/keypairs/{resourceId}").outType(String.class)
            .description("Delete a registered keypair")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:KeyPairsController?method=deleteKeyPair(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/keypairs/{resourceId}").outType(KeyPair.class)
            .description("Retrieve a specific keypair object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:KeyPairsController?method=getKeyPair(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/keypairs").outType(KeyPair[].class)
            .description("Retrieve a list of accessible keypairs for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:KeyPairsController?method=getKeyPairs")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/keypairs/{resourceId}").type(KeyPair.class).outType(KeyPair.class)
            .description("Fully update a registered keypair")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("keypair")
                    .type(body)
                    .description("KeyPair object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,KeyPair.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:KeyPairsController?method=updateKeyPair(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/keypairs/{resourceId}").type(KeyPair.class).outType(KeyPair.class)
            .description("Partially update a registered keypair")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("keypair")
                    .type(body)
                    .description("KeyPair object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,KeyPair.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:KeyPairsController?method=updateKeyPairAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/libraries").type(Library.class).outType(Library.class)
            .description("Add a new library")
                .param()
                    .required(true)
                    .name("library")
                    .type(body)
                    .description("Library object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Library.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibrariesController?method=addLibrary(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/libraries/{resourceId}").outType(String.class)
            .description("Delete a registered library")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibrariesController?method=deleteLibrary(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/libraries").outType(Library[].class)
            .description("Retrieve a list of accessible libraries for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibrariesController?method=getLibraries")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/libraries/{resourceId}").outType(Library.class)
            .description("Retrieve a specific library object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibrariesController?method=getLibrary(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/libraries/{resourceId}").type(Library.class).outType(Library.class)
            .description("Fully update a registered library")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("library")
                    .type(body)
                    .description("Library object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Library.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibrariesController?method=updateLibrary(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/libraries/{resourceId}").type(Library.class).outType(Library.class)
            .description("Partially update a registered library")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("library")
                    .type(body)
                    .description("Library object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Library.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibrariesController?method=updateLibraryAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/libraryapiversions").type(LibraryApiVersion.class).outType(LibraryApiVersion.class)
            .description("Add a new libraryapiversion")
                .param()
                    .required(true)
                    .name("libraryapiversion")
                    .type(body)
                    .description("LibraryApiVersion object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,LibraryApiVersion.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibraryApiVersionsController?method=addLibraryApiVersion(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/libraryapiversions/{resourceId}").outType(String.class)
            .description("Delete a registered libraryapiversion")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibraryApiVersionsController?method=deleteLibraryApiVersion(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/libraryapiversions/{resourceId}").outType(LibraryApiVersion.class)
            .description("Retrieve a specific libraryapiversion object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibraryApiVersionsController?method=getLibraryApiVersion(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/libraryapiversions").outType(LibraryApiVersion[].class)
            .description("Retrieve a list of accessible libraryapiversions for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibraryApiVersionsController?method=getLibraryApiVersions")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/libraryapiversions/{resourceId}").type(LibraryApiVersion.class).outType(LibraryApiVersion.class)
            .description("Fully update a registered libraryapiversion")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("libraryapiversion")
                    .type(body)
                    .description("LibraryApiVersion object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,LibraryApiVersion.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibraryApiVersionsController?method=updateLibraryApiVersion(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/libraryapiversions/{resourceId}").type(LibraryApiVersion.class).outType(LibraryApiVersion.class)
            .description("Partially update a registered libraryapiversion")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("libraryapiversion")
                    .type(body)
                    .description("LibraryApiVersion object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,LibraryApiVersion.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:LibraryApiVersionsController?method=updateLibraryApiVersionAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/pipelines").type(Pipeline.class).outType(Pipeline.class)
            .description("Add a new pipeline")
                .param()
                    .required(true)
                    .name("pipeline")
                    .type(body)
                    .description("Pipeline object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Pipeline.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:PipelinesController?method=addPipeline(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/pipelines/{resourceId}").outType(String.class)
            .description("Delete a registered pipeline")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:PipelinesController?method=deletePipeline(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/pipelines/{resourceId}").outType(Pipeline.class)
            .description("Retrieve a specific pipeline object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:PipelinesController?method=getPipeline(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/pipelines").outType(Pipeline[].class)
            .description("Retrieve a list of accessible pipelines for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:PipelinesController?method=getPipelines")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/pipelines/{resourceId}").type(Pipeline.class).outType(Pipeline.class)
            .description("Fully update a registered pipeline")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("pipeline")
                    .type(body)
                    .description("Pipeline object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Pipeline.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:PipelinesController?method=updatePipeline(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/pipelines/{resourceId}").type(Pipeline.class).outType(Pipeline.class)
            .description("Partially update a registered pipeline")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("pipeline")
                    .type(body)
                    .description("Pipeline object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Pipeline.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:PipelinesController?method=updatePipelineAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/sourcerepositories").type(SourceRepository.class).outType(SourceRepository.class)
            .description("Add a new sourcerepository")
                .param()
                    .required(true)
                    .name("sourcerepository")
                    .type(body)
                    .description("SourceRepository object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,SourceRepository.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceRepositoriesController?method=addSourceRepository(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/sourcerepositories/{resourceId}").outType(String.class)
            .description("Delete a registered sourcerepository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceRepositoriesController?method=deleteSourceRepository(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/sourcerepositories").outType(SourceRepository[].class)
            .description("Retrieve a list of accessible sourcerepositories for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceRepositoriesController?method=getSourceRepositories")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/sourcerepositories/{resourceId}").outType(SourceRepository.class)
            .description("Retrieve a specific sourcerepository object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceRepositoriesController?method=getSourceRepository(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/sourcerepositories/{resourceId}").type(SourceRepository.class).outType(SourceRepository.class)
            .description("Fully update a registered sourcerepository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("sourcerepository")
                    .type(body)
                    .description("SourceRepository object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,SourceRepository.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceRepositoriesController?method=updateSourceRepository(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/sourcerepositories/{resourceId}").type(SourceRepository.class).outType(SourceRepository.class)
            .description("Partially update a registered sourcerepository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("sourcerepository")
                    .type(body)
                    .description("SourceRepository object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,SourceRepository.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceRepositoriesController?method=updateSourceRepositoryAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/users").type(User.class).outType(User.class)
            .description("Add a new user")
                .param()
                    .required(true)
                    .name("user")
                    .type(body)
                    .description("User object to be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,User.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UsersController?method=addUser(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/users/{resourceId}").outType(String.class)
            .description("Delete a registered user")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UsersController?method=deleteUser(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/users/{resourceId}").outType(User.class)
            .description("Retrieve a specific user object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UsersController?method=getUser(${header.resourceId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/users").outType(User[].class)
            .description("Retrieve a list of accessible users for authenticated user")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UsersController?method=getUsers")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/users/{resourceId}").type(User.class).outType(User.class)
            .description("Fully update a registered user")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("user")
                    .type(body)
                    .description("User object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,User.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UsersController?method=updateUser(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .patch("/users/{resourceId}").type(User.class).outType(User.class)
            .description("Partially update a registered user")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("resourceId")
                    .type(path)
                    .description("resource's id")
                .endParam()
                .param()
                    .required(true)
                    .name("user")
                    .type(body)
                    .description("User object to be updated")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,User.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:UsersController?method=updateUserAttributes(${header.resourceId},${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest();
    }
}